
#include <math.h>
#include <GL/glew.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdlib.h>
#include "lbm.h"
#include "particles.h"

#define PC 2
float par[nparmax*PC]; 

void initpar(void)
{
	for ( int k=0; k<nparmax; k++)
	{
		par[k*PC]	= rand()/float(RAND_MAX);
		par[k*PC+1]	= rand()/float(RAND_MAX);
	}
}
float BilinearInterpolation(float x,float y,int x1,int x2,int y1,int y2,float f11,float f21,float f22,float f12)
{
	// @Numerical Recipes
	float t = (x-x1) / (x2 - x1);
	float u = (y-y1) / (y2 - y1);
	return (1-t)*(1-u)*f11 + t*(1-u)*f21 + t*u*f22 + (1-t)*u*f12;
}
void movepar(float dt)
{
	int i,j,k;
	int ip,jp;
	float x,y;
	for ( k=0; k<nparmax; k++)
	{
		x = par[k*PC];
		y = par[k*PC+1];
		i = int(x * (L-1) + L ) % (L);	// x=0 => i = 0, x=1 => L-2
		j = int(y * (L-1) + L ) % (L);
		ip = int(x * (L-1) + L + 1 ) % (L);
		jp = int(y * (L-1)+ L + 1 ) % (L);
		x = x + BilinearInterpolation(x*(L-1),y*(L-1), i,ip, j,jp, U[ i+j*L ],U[ip+j*L],U[ip+jp*L],U[i+jp*L]) * dt;
		y = y + BilinearInterpolation(x*(L-1),y*(L-1), i,ip, j,jp, V[ i+j*L ],V[ip+j*L],V[ip+jp*L],V[i+jp*L]) * dt;
		if(x<0) x = 1+x;
		if(y<0)	y = 1+y;
		if(x>1)	x = x-1;
		if(y>1)	y = y-1;
		par[k*PC]	= x;
		par[k*PC+1]	= y;
	}
}
void drawpar(void)
{
	glEnable (GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable (GL_POINT_SMOOTH);
	glHint (GL_POINT_SMOOTH_HINT, GL_NICEST);
	// VBO RENDER
	glPointSize(2);
	glColor4f(1.0,1.0,1.0,0.7f);
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(2,GL_FLOAT,0,par);
	glDrawArrays(GL_POINTS,0,nparmax);
	glDisableClientState(GL_VERTEX_ARRAY);
}
